From f974f7baf90fdcca2e5cce62efbb189320153aad Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 8/48] Implement ModuleArtifacts


---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index b12d268..fb4fc22 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -161,7 +161,6 @@ class ModuleMetadata(object):
 
         self.buildopts = ModuleBuildopts()
         self.components = ModuleComponents()
-        self.artifacts = ModuleArtifacts()
 
 
     def __repr__(self):
@@ -745,10 +744,16 @@ class ModuleMetadata(object):
     @property
     def artifacts(self):
         """A ModuleArtifacts instance representing the module's artifacts."""
-        return self._artifacts
+        artifacts = ModuleArtifacts(parent=self)
+        artifacts.rpms = set(self.module.get_rpm_artifacts().get())
+        return artifacts
 
     @artifacts.setter
     def artifacts(self, o):
         if not isinstance(o, ModuleArtifacts):
             raise TypeError("artifacts: data type not supported")
-        self._artifacts = o
+
+        rpms = Modulemd.SimpleSet()
+        rpms.set(list(o.rpms))
+
+        self.module.set_rpm_artifacts(rpms)
diff --git a/modulemd/artifacts.py b/modulemd/artifacts.py
index 6d52a00..efdc228 100644
--- a/modulemd/artifacts.py
+++ b/modulemd/artifacts.py
@@ -25,12 +25,15 @@
 
 supported_content = ( "rpms", )
 
+from gi.repository import Modulemd
+
 class ModuleArtifacts(object):
     """Class representing a particular module artifacts."""
 
-    def __init__(self):
+    def __init__(self, parent=None):
         """Creates a new ModuleArtifacts instance."""
         self.rpms = set()
+        self.parent = parent
 
     def __repr__(self):
         return ("<ModuleArtifacts: "
@@ -57,6 +60,11 @@ class ModuleArtifacts(object):
                 raise TypeError("artifacts.rpms: data type not supported")
         self._rpms = ss
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_artifacts(ss)
+
     def add_rpm(self, s):
         """Adds an NEVRA to the artifact set.
 
@@ -66,6 +74,11 @@ class ModuleArtifacts(object):
             raise TypeError("artifacts.add_rpm: data type not supported")
         self._rpms.add(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_artifacts(ss)
+
     def del_rpm(self, s):
         """Removes the supplied NEVRA from the artifact set.
 
@@ -75,6 +88,16 @@ class ModuleArtifacts(object):
             raise TypeError("artifacts.del_rpm: data type not supported")
         self._rpms.discard(s)
 
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_artifacts(ss)
+
     def clear_rpms(self):
         """Clear the RPM artifacts set."""
         self._rpms.clear()
+
+        if hasattr(self, 'parent'):
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            self.parent.module.set_rpm_artifacts(ss)

